#define SND         ' Sound verwenden

#ifdef SND
  #include once "include/bass24.bi"
#endif
#include once "include/laser303.bi"
#include once "include/lasereditor.inc"

chdir exepath
screen 18, 32
cls
const VERSIONSNUMMER = "3.03"
const REVISION = "100827"

if command = "-v" or command = "--version" then
  print "Laser " & VERSIONSNUMMER & "." & REVISION & ", compiliert am " & mid(__DATE__, 4, 2) & ". ";
  print monat(val(__DATE__)-1) & " " & right(__DATE__, 4) & ", " & __TIME__ & " Uhr."
  print "Idee und Umsetzung von Stephan Markthaler"
  print "Das Programm steht unter der General Public Licence (GPL), Version 3"
  print
  end
elseif command = "-h" or command = "--help" then
  print "Rufen Sie das Programm ohne Parameter auf, um das Spiel zu starten."
  print "Weitere Parameter:"
  print "-d, --debug   : Startet das Spiel im Debug-Modus."
  print "-e, --editor  : Startet den Leveleditor."
  print "-v, --version : Zeigt die aktuelle Versionsnummer an."
  print
  end
elseif command = "-d" or command = "--debug" then
  DEBUG = -1
end if

'verfuegbare Level einlesen
levelname(1) = dir("level/*.lev")
AnzahlLevelnamen = 1
if levelname(1) = "" then
  print "FEHLER: Keine Laserlevel gefunden!"
  getkey
  end
end if
do
  levelname(AnzahlLevelnamen+1) = dir("")
  if levelname(AnzahlLevelnamen+1) = "" then exit do
  AnzahlLevelnamen += 1
loop until AnzahlLevelnamen = 255
quicksort(levelname(), 1, AnzahlLevelnamen)
'evtl. Nummerierung abschneiden
for i as short = 1 to AnzahlLevelnamen
  if levelname(i)[0] > 47 and levelname(i)[0] < 58 then
    if levelname(i)[1] = 45 then
      anzeigename(i) = mid(levelname(i), 3)
    elseif levelname(i)[1] > 47 and levelname(i)[1] < 58 then
      if levelname(i)[2] = 45 then
        anzeigename(i) = mid(levelname(i), 4)
      elseif levelname(i)[2] > 47 and levelname(i)[2] < 58 and levelname(i)[3] = 45 then
        anzeigename(i) = mid(levelname(i), 5)
      end if
    end if
  else
    anzeigename(i) = levelname(i)
  end if
  anzeigename(i) = left(anzeigename(i), min(len(anzeigename(i))-4, 12))
next

' Spiegel laden
read AnzahlSpiegel
for i=0 to AnzahlSpiegel + 1
  with spiegel(i)
    read .reflekto, .reflektu, .reflektl, .reflektr, .naechster, .dreh, .sicht, .href
    if DEBUG then print "lade " & .href
    if .href = "" then
      .bild = pload(grafikordner & "fehler" & grafiktyp)
      .bildklein = pload(grafikordner & "fehler_klein" & grafiktyp)
    elseif .dreh = 1 or .dreh = 2 then
      .bild  = pload(grafikordner & .href & "0" & grafiktyp)
      .bild1 = pload(grafikordner & .href & "1" & grafiktyp)
      .bild2 = pload(grafikordner & .href & "2" & grafiktyp)
      .bild3 = pload(grafikordner & .href & "3" & grafiktyp)
      .bild4 = pload(grafikordner & .href & "4" & grafiktyp)
      .bildklein = pload(grafikordner & .href & "_klein" & grafiktyp)
    else
      .bild  = pload(grafikordner & .href & grafiktyp)
      if left(.href, 6) = "mensch" then
        .bildklein = pload(grafikordner & "leer_klein" & grafiktyp)
      else
        .bildklein = pload(grafikordner & .href & "_klein" & grafiktyp)
      end if
    end if
  end with
next
' Sonderroutine fuer sich oeffnendes Loch
spiegel(0).bild1 = pload(grafikordner & "loch4" & grafiktyp)
spiegel(0).bild2 = pload(grafikordner & "loch3" & grafiktyp)
spiegel(0).bild3 = pload(grafikordner & "loch2" & grafiktyp)
spiegel(0).bild4 = pload(grafikordner & "loch1" & grafiktyp)

' Menschen laden
for i=1 to 2
  for k=0 to 4
    mensch(i).bild(1, k) = pload(grafikordner & "mensch" & str(i) & "o" & str(k) & grafiktyp)
    mensch(i).bild(2, k) = pload(grafikordner & "mensch" & str(i) & "u" & str(k) & grafiktyp)
    mensch(i).bild(3, k) = pload(grafikordner & "mensch" & str(i) & "l" & str(k) & grafiktyp)
    mensch(i).bild(4, k) = pload(grafikordner & "mensch" & str(i) & "r" & str(k) & grafiktyp)
  next
  mensch(i).bild(0, 1) = pload(grafikordner & "mensch" & str(i) & "_sitzo" & grafiktyp)
  mensch(i).bild(0, 2) = pload(grafikordner & "mensch" & str(i) & "_sitzu" & grafiktyp)
  mensch(i).bild(0, 3) = pload(grafikordner & "mensch" & str(i) & "_sitzl" & grafiktyp)
  mensch(i).bild(0, 4) = pload(grafikordner & "mensch" & str(i) & "_sitzr" & grafiktyp)
next
menubild = pload(grafikordner & "menu" & grafiktyp)

'Daten fuer die Steine, Spiegel usw.
'.reflekto, -u, -l, -r, .naechster, .dreh, .sicht, .href
'.dreh:  1:drehbar; 2:pulsierend; 3:Spezial (z. B. Hilfsstein)
'.sicht: betretbar + 2*(Laser sichtbar waag) + 4*(Laser sichtbar senk)
data 42
data 1,2,4,8,36,0,7,"leer"
data 1,0,0,0,1,0,2,"laser_o"
data 0,2,0,0,2,0,2,"laser_u"
data 0,0,4,0,3,0,4,"laser_l"
data 0,0,0,8,4,0,4,"laser_r"
data 1,2,4,8,5,0,0,"mensch1u0"     'Ersatz fuer versteckte Laserkanonen
data 0,0,0,0,6,2,0,"bruchstein"    'Ersatz fuer zerbrechenden Stein
data 0,0,0,0,7,0,0,"diamant_hell"
data 1,2,4,8,8,0,6,"mensch1_sitzu"
data 1,2,4,8,9,0,6,"mensch2_sitzu"
data 0,0,0,0,10,0,0,"mensch2u0"

data 4,8,1,2,0,0,0,"normal_schieb_lo"   ' 11 - 20
data 8,4,2,1,0,0,0,"normal_schieb_ro"
data 4,8,1,2,14,1,0,"normal_dreh_lo"
data 8,4,2,1,13,1,0,"normal_dreh_ro"
data 5,10,5,10,0,0,0,"halb_schieb_lo"
data 9,6,6,9,0,0,0,"halb_schieb_ro"
data 5,10,5,10,18,1,0,"halb_dreh_lo"
data 9,6,6,9,17,1,0,"halb_dreh_ro"
data 0,12,1,1,0,0,0,"dreieck_schieb_o"
data 8,8,3,0,0,0,0,"dreieck_schieb_r"

data 12,0,2,2,0,0,0,"dreieck_schieb_u"  ' 21 - 30
data 4,4,0,3,0,0,0,"dreieck_schieb_l"
data 0,12,1,1,24,1,0,"dreieck_dreh_o"
data 8,8,3,0,25,1,0,"dreieck_dreh_r"
data 12,0,2,2,26,1,0,"dreieck_dreh_u"
data 4,4,0,3,23,1,0,"dreieck_dreh_l"
data 0,0,0,0,0,0,0,"stein_schieb"
data 1,2,0,0,0,0,4,"stein_schieb_ou"
data 0,0,4,8,0,0,2,"stein_schieb_lr"
data 0,0,0,0,30,0,0,"stein_fest"

data 1,2,0,0,32,1,4,"stein_fest_ou"     ' 31 - 40
data 0,0,4,8,31,1,2,"stein_fest_lr"
data 1,2,4,8,33,0,6,"durchsichtig"
data 1,2,4,8,34,2,0,"bruchstein"
data 1,2,4,8,35,0,7,"durchgang"
data 1,2,4,8,0,2,7,"loch"
data 0,0,0,0,37,0,0,"diamant_dunkel"
data 0,0,0,0,38,2,0,"pfeil_o"
data 0,0,0,0,39,2,0,"pfeil_u"
data 0,0,0,0,40,2,0,"pfeil_l"

data 0,0,0,0,41,2,0,"pfeil_r"
data 0,0,0,0,42,3,0,"hilfe"
data 0,0,0,0,43,0,0,"fehler"             'FEHLERHAFTES FELD

SteuerungPfeil=1
'SteuerungAdws=1
'Steuerung4682=1
'SteuerungJoy1=1
'SteuerungJoy2=1

' Font initialisieren
font = font_laden("grafik/font.bmp")

if left(command, 2) = "-e" then
  modus = "schwer"
  DEBUG = -1
  editor(mid(command, 4))
elseif left(command, 8) = "--editor" then
  modus = "schwer"
  DEBUG = -1
  editor(mid(command, 10))
else
  'normaler Spielablauf

  ' Sound initialisieren
  sound = 0
  #ifdef SND
    if BASS_Init(-1, 44100, BASS_DEVICE_8BITS, 0, 0) = 0 then
      if DEBUG then
        print "BASS konnte nicht initialisiert werden! Fehlercode: " & BASS_ErrorGetCode()
        getkey
      end if
    else
      sound = SOUND_MUSIK_OK or SOUND_EFFEKT_OK
    end if
    if sound then
      sound_musik = BASS_MusicLoad(0, strptr(FILE_MUSIK), 0, 0, BASS_MUSIC_POSRESET Or BASS_MUSIC_AUTOFREE Or BASS_SAMPLE_LOOP, 0)
      if sound_musik = 0 then
        sound and= 255-SOUND_MUSIK_OK
        if DEBUG then
          print "BASS: Musik konnte nicht geladen werden! Fehlercode: " & BASS_ErrorGetCode()
          getkey
        end if
      else
        BASS_ChannelPlay(sound_musik, 0)
        BASS_ChannelSetPosition(sound_musik, MUSIC_MENU, BASS_POS_MUSIC_ORDER)
      end if
      sound_laser = sound_laden(FILE_LASER)
      sound_dreh  = sound_laden(FILE_DREH)
      sound_bruch = sound_laden(FILE_BRUCH)
    end if
  #endif
  ' ***** Startmenu *****
  dim as ubyte auswahl=0, startlevel=1, levelset=1
  dim taste as string, text as string
  dim typ as ubyte, kommentar as string*255, autor as string*63, version as ushort
  dim spielergebnis as TypSpielergebnis, lev as ubyte =1
  ladeinfo(levelname(1), typ, kommentar, autor, version)
  laden(levelname(levelset), 1)
  modus = "leicht"
  if sound and SOUND_MUSIK_OK then sound or= SOUND_MUSIK_AN
  if sound and SOUND_EFFEKT_OK then sound or= SOUND_EFFEKT_AN
  do
    windowtitle "Laser " & VERSIONSNUMMER & " - Startmenue"
    color &hffffff
    screenlock
    cls
    put (220, 59), menubild
    draw string (268, 202), "Einstellungen"
    draw string (264, 242), "Spielanleitung"
    draw string (268, 282), "Spiel beenden"
    for i as ubyte = 13 to 20
      for k as ubyte = 6 to 14 step 2
        stein(i, k, 33)
      next
    next
    for i as ubyte = 1 to 32
      for k as ubyte = 5 to 24
        stklein(i*5+235 , k*5+295, spiegel(feld(i, k) and 63).bildklein, 2)
      next
    next
    text = "Start Level " & startlevel
    draw string (320-len(text)*4,  82), text
    text = "Set " & anzeigename(levelset)
    draw string (320-len(text)*4, 122), text
    draw string (268, 162), "Modus: " & modus
    screenunlock
    dim as double zaehlzeit = timer
    i = 0
    stein(12, 5+auswahl*2, 41, i)
    stein(21, 5+auswahl*2, 40, i)
    do
      sleep 1
      taste = inkey
    loop until taste = "" and multikey(57) = 0
    do
      if timer > zaehlzeit + .1 then
        i = iif(i>3, 0, i+1)
        stein(12, 5+auswahl*2, 41, i)
        stein(21, 5+auswahl*2, 40, i)
        zaehlzeit = timer
      end if
      if multikey(B_O) or multikey(Z_O) or multikey(P_O) then
        stein(12, 5+auswahl*2, 30)
        stein(21, 5+auswahl*2, 30)
        auswahl = iif(auswahl<1, 5, auswahl-1)
        stein(12, 5+auswahl*2, 41, i)
        stein(21, 5+auswahl*2, 40, i)
        warte 0.2
      end if
      if multikey(B_U) or multikey(Z_U) or multikey(P_U) then
        stein(12, 5+auswahl*2, 30)
        stein(21, 5+auswahl*2, 30)
        auswahl = iif(auswahl>4, 0, auswahl+1)
        stein(12, 5+auswahl*2, 41, i)
        stein(21, 5+auswahl*2, 40, i)
        warte 0.2
      end if
      if multikey(B_R) or multikey(Z_R) or multikey(P_R) then
        select case auswahl
        case 0
          startlevel = iif(startlevel>=levanz, 1, startlevel+1)
          laden(levelname(levelset), startlevel)
          warte 0.2
          exit do ' neu zeichnen
        case 1
          levelset = iif(levelset>=AnzahlLevelnamen, 1, levelset+1)
          startlevel = 1
          laden(levelname(levelset), 1)
          ladeinfo(levelname(levelset), typ, kommentar, autor, version)
          warte 0.2
          exit do ' neu zeichnen
        case 2
          select case modus
            case " frei " : modus = "leicht"
            case "leicht" : modus = "mittel"
            case "mittel" : modus = "schwer"
            case "schwer" : modus = " frei "
          end select
          warte 0.2
          exit do ' neu zeichnen
        end select
      end if
      if multikey(B_L) or multikey(Z_L) or multikey(P_L) then
        select case auswahl
        case 0
          startlevel = iif(startlevel<2, levanz+0, startlevel-1)
          laden(levelname(levelset), startlevel)
          warte 0.2
          exit do ' neu zeichnen
        case 1
          levelset = iif(levelset<2, AnzahlLevelnamen+0, levelset-1)
          startlevel = 1
          laden(levelname(levelset), 1)
          ladeinfo(levelname(levelset), typ, kommentar, autor, version)
          warte 0.2
          exit do ' neu zeichnen
        case 2
          select case modus
            case " frei " : modus = "schwer"
            case "leicht" : modus = " frei "
            case "mittel" : modus = "leicht"
            case "schwer" : modus = "mittel"
          end select
          warte 0.2
          exit do ' neu zeichnen
        end select
      end if
      if multikey(28) or multikey(57) then
        if auswahl = 0 then
          leben = 3
          punkte = 0
          #ifdef SND
            if sound and SOUND_MUSIK_AN then
              BASS_ChannelSetPosition(sound_musik, MUSIC_INGAME, BASS_POS_MUSIC_ORDER)
            end if
          #endif
          do
            windowtitle "Laser " & VERSIONSNUMMER & " - " _
              & left(levelname(levelset), len(levelname(levelset))-4) _
              & ", Level " & startlevel
            spielergebnis = spiel(levelname(levelset), startlevel)
            leben -= spielergebnis.leben
            if leben < 1 or spielergebnis.typ > 10 then exit do
            if spielergebnis.typ=1 or spielergebnis.typ=9 then startlevel += 1
            if spielergebnis.typ=10 then startlevel -= 1
            if spielergebnis.typ>8 then punkte = 0
          loop until startlevel > levanz
          if startlevel > levanz then startlevel = levanz
          #ifdef SND
            if sound and SOUND_MUSIK_AN then _
               BASS_ChannelSetPosition(sound_musik, MUSIC_MENU, BASS_POS_MUSIC_ORDER)
          #endif
          exit do ' neu zeichnen
        end if
        if auswahl = 1 then
          levelset = iif(levelset>=AnzahlLevelnamen, 1, levelset+1)
          startlevel = 1
          laden(levelname(levelset), 1)
          ladeinfo(levelname(levelset), typ, kommentar, autor, version)
          exit do ' neu zeichnen
        end if
        if auswahl = 2 then
          select case modus
            case " frei " : modus = "leicht"
            case "leicht" : modus = "mittel"
            case "mittel" : modus = "schwer"
            case "schwer" : modus = " frei "
          end select
          warte 0.2
          exit do ' neu zeichnen
        end if
        if auswahl = 4 then
          anleitung
          laden(levelname(levelset), startlevel)
          exit do ' neu zeichnen
        end if
        if auswahl = 5 then taste = chr(27) : exit do
      end if
      taste = inkey
    loop until taste = chr(27) or taste = chr(255) & "k"
  loop until taste = chr(27) or taste = chr(255) & "k"
end if

destructor TypSpiegel
  imagedestroy this.bild
  if this.dreh = 1 or this.dreh = 2 then
    imagedestroy this.bild1
    imagedestroy this.bild2
    imagedestroy this.bild3
    imagedestroy this.bild4
    imagedestroy this.bildklein
  end if
end destructor

destructor TypMensch
  for i as ubyte = 0 to 4 : for k as ubyte = 0 to 4
    imagedestroy this.bild(i, k)
  next : next
end destructor

sub destruct destructor
  #ifdef SND
    BASS_Free
  #endif
  imagedestroy menubild
  imagedestroy font
end sub

sub anleitung
  _MODUS_ = 2
  dim as ubyte seite = 1, i, k, sx, sy
  dim as string taste
  do
  cls
  do : loop until inkey = ""
  taste = ""
  select case seite
  case 1
    erase laser, feld
    for i = 1 to 32: feld(i, 16) = 30: next
    feld(5, 18) = 4 : feld(25, 24) = 1 : feld(12, 21) = 5
    zeichnefeld 16
    rechne 6, 18, 8
    rechne 25, 23, 1
    color &hffffff : print tab(73); "(1/9)" : print "ZIEL DES SPIELES"
    print : color &hbbbbbb
    print "In jedem Level sind ein oder mehrere Laserkanonen enthalten, die konstant einen"
    print "Laserstrahl abfeuern. Von diesen Laserstrahlen solltest du dich auf keinen Fall"
    print "treffen lassen,  denn sie sind fuer die Spielerfigur toedlich.  Stattdessen ist"
    print "es Aufgabe,  die Kanonen zu zerstoeren.  Um das zu erreichen,  musst du einfach"
    print "nur den Laserstrahl auf die Kanonen lenken."
    color &hffffff : print : print "DIE SCHWIERIGKEITEN"
    print : color &hbbbbbb
    print "Einfach nur? Nun - es gibt da doch ein paar kleinere Schwierigkeiten. Zunaechst"
    print "darfst du dich nicht vom Laserstrahl treffen lassen.  Es gibt aber auch gemeine"
    print "Loecher, vor denen du dich hueten solltest.  Ausserdem rennt die Zeit - je nach"
    print "Schwierigkeitsgrad bleibt dir mehr oder weniger Zeit, das Level zu loesen.  Und"
    print "wenn sich dann auch noch Spiegel selbstaendig machen ... aber dazu spaeter."
    print
    locate , 53: print "(bitte eine Taste druecken)"
    do
      sleep 1
      taste = inkey
    loop until taste<>""

  case 2
    erase laser, feld
    for i = 1 to 32 : feld(i, 12) = 30 : next
    feld(5, 15) = 4: feld(27, 15) = 13: feld(27, 22) = 12
    zeichnefeld 12
    rechne 6, 15, 8
    color &hffffff : print tab(73) ; "(2/9)" : print "SPIEGLEIN, SPIEGLEIN ..."
    print : color &hbbbbbb
    print "Fuer den Auftrag, die Kanonen zu zerstoeren,  leisten Spiegel oft unschaetzbare"
    print "Dienste. Nur mit ihnen kann der Laserstrahl umgelenkt werden."
    print "Einen Spiegel kannst du entweder drehen oder schieben, aber immer nur eines von"
    print "beidem.  Die drehbaren Spiegel erkennst du an einem Punkt in der Mitte, der die"
    print "Achse darstellt, um die der Spiegel gedreht werden kann."
    print "Unten siehst du zwei solcher Spiegel.  Der obere laesst sich drehen, der untere"
    print "verschieben."
    print
    locate , 53 : print "(bitte eine Taste druecken)"
    do
      sleep 1
      taste = inkey
    loop until taste<>""

  case 3
    erase laser, feld
    for i = 1 to 32: feld(i, 12) = 30: next
    feld(5, 15) = 4 : feld(23, 15) = 21 : feld(23, 22) = 23 : feld(14, 22) = 15
    feld(11, 22) = 22 : feld(27, 22) = 18 : feld(27, 17) = 24
    zeichnefeld 12
    rechne 6, 15, 8
    color &hffffff: print tab(73); "(3/9)": print "DREIECKSSPIEGEL UND ANDERE FEINHEITEN"
    print : color &hbbbbbb
    print "Neben den 'normalen' Spiegeln  gibt es auch dreieckige.  Ihre Besonderheit ist,"
    print "dass sie den Laserstrahl aufteilen koennen. Trifft der Laser auf die Spitze des"
    print "Dreiecks, so wird er nach beiden Seiten hin abgelenkt. Trifft er auf die gerade"
    print "Rueckseite,  so wird er absorbiert.  Dreiecksspiegel werden immer im Uhrzeiger-"
    print "sinn gedreht (natuerlich nur, wenn sie drehbar sind)."
    print "Halbdurchlaessige Spiegel tun genau das, was ihr Name bereits sagt:  sie lenken"
    print "den Laser zum Teil ab, zum Teil lassen sie ihn hindurch."
    print : locate , 53 : print "(bitte eine Taste druecken)"
    do
      sleep 1
      taste = inkey
    loop until taste<>""

  case 4
    erase laser, feld
    for i = 1 to 32 : feld(i, 15) = 30 : next
    feld(5, 19) = 4 : feld(5, 20) = 4 : feld(6, 19) = 32 : feld(6, 20) = 31
    feld(16, 19) = 22 : feld(16, 16) = 21 : feld(11, 16) = 29 : feld(26, 16) = 30
    feld(16, 23) = 23 : feld(9, 23) = 28 : feld(27, 23) = 27 : feld(28, 23) = 5
    for i = 16 to 24: feld(22, i) = 33: next
    zeichnefeld 15
    rechne 6, 19, 8
    rechne 6, 20, 8
    color &hffffff : print tab(73) ; "(4/9)" : print "HALS- UND STEINBRUCH"
    print : color &hbbbbbb
    print "Steine stehen einfach nur im Weg herum.  Manchmal ist das gut, weil sie dadurch"
    print "den Laserstrahl daran hindern, deine Spielfigur zu treffen. Manchmal jedoch ist"
    print "es auch hinderlich, weil sie dir den Weg versperren.  Manche Steine lassen sich"
    print "verschieben. Diese sind braun, wogegen die nicht verschiebbaren grau sind."
    color &hffffff : print : print "STEIN MIT LOCH"
    print : color &hbbbbbb
    print "Es gibt sogar solche Steine, die den Laser nur in eine Richtung blockieren. Wie"
    print "bei den Spiegeln lassen sich hier nicht verschiebbare Steine drehen.  Ab und zu"
    print "kann man dadurch eine Laserkanone 'an- und ausschalten'."
    print "Durchsichtige Steine blockieren die Laserstrahlen ueberhaupt nicht.  Sie stehen"
    print "einfach nur im Weg herum und hindern dich daran,  an wichtige Orte zu gelangen."
    print : locate , 53: print "(bitte eine Taste druecken)"
    do
      sleep 1
      taste = inkey
    loop until taste<>""

  case 5
    erase laser, feld
    for i = 1 to 32 : feld(i, 16) = 30: next
    feld(5, 18) = 4 : feld(16, 18) = 11 : feld(14, 23) = 15
    feld(10, 23) = 35 : feld(18, 23) = 35 : feld(6, 22) = 34
    feld(28, 18) = 3 : feld(27, 19) = 36 : feld(25, 18) = 36
    feld(23, 18) = 37 : feld(24, 21) = 37
    for i = 10 to 18 : feld(i, 22) = 35 : feld(i, 24) = 35 : next
    zeichnefeld 16
    rechne 6, 18, 8
    rechne 27, 18, 4
    color &hffffff : print tab(73); "(5/9)" : print "DER GANZE REST"
    print : color &hbbbbbb
    print "Ein bisschen besser als durchsichtige Steine sind die Passagen. Du kannst durch"
    print "sie hindurch gehen, jedoch keine Steine hinein schieben.  Der halbdurchlaessige"
    print "Spiegel unten ist von einer Passage umschlossen.  Du kannst ihn nur nach rechts"
    print "oder links schieben."
    print "Bruechige Steine sind nichts anderes als hinderlich.  Wenn sie dir den Weg ver-"
    print "sperren, kannst du sie durch einen Laserstrahl zerstoeren."
    print "Die nutzlosesten Gegenstaende sind Loecher. Sie verschlucken wahllos alles, was"
    print "sich auf ihnen befindet, ausser Laserstrahlen. Unnoetig zu sagen, dass du nicht"
    print "in ein Loch fallen solltest, weil du sonst ein Leben verlierst. Immerhin kannst"
    print "du ein Loch schliessen, indem du einen Stein hinein schiebst."
    print "Da ein Spiel nicht nur aus unnuetzen Dingen bestehen sollte,  gibt es auch noch"
    print "die Diamanten. Wenn sie vom Laser getroffen werden, dann strahlen sie im hellen"
    print "Licht. Warum das nuetzlich ist? Natuerlich weil es Zusatzpunkte gibt!"
    print : locate , 53 : print "(bitte eine Taste druecken)"
    do
      sleep 1
      taste = inkey
    loop until taste<>""

  case 6
    erase laser, feld
    for i = 1 to 32: feld(i, 14) = 30: next
    feld(5, 19) = 4 : feld(16, 19) = 13 : feld(16, 22) = 23
    feld(16, 17) = 31 : feld(16, 15) = 21 : feld(6, 22) = 36
    zeichnefeld 14
    rechne 6, 19, 8
    color &hffffff : print tab(73); "(6/9)" : print "UND ... ACTION!"
    print : color &hbbbbbb
    print "Wuerden die Spiegel und Steine einfach nur so in der Gegend herum stehen,  dann"
    print "waere das ziemlich langweilig. Deswegen koennen sich einige von ihnen sogar von"
    print "selbst bewegen - manche schneller, manche weniger schnell."
    print "Wenn du dich selbst einmal am Leveleditor versuchen willst,  dann kannst du mit"
    print "einem rechten Mausklick die Drehgeschwindigkeit eines Steines veraendern - wenn"
    print "der gewaehlte Gegenstand, drehbar ist.  Mit + und - kannst du die Drehgeschwin-"
    print "digkeit aendern."
    print "Aber auch Loecher und freie Felder koennen dieses Attribut erhalten.  Dann ver-"
    print "wandelt sich das Feld in ein Loch, das sich selbstaendig oeffnet und schliesst."
    print : locate , 53: print "(bitte eine Taste druecken)"
    dim t as double
    t = timer
    i = 0
    do
      if (timer - t) > .1 then
        i += 1
        t = timer
        if (i mod 12) = 0 then
          sx = 16
          sy = 19
          rechneweg 16, 19
          feld(16, 19) = 27 - feld(16, 19)
          stein 16, 19
          sx = 0
          rechne 16, 19
        end if
        if (i mod 19) = 0 then
          sx = 16
          sy = 17
          rechneweg 16, 17
          feld(16, 17) = 63 - feld(16, 17)
          stein 16, 17
          sx = 0
          rechne 16, 17
        end if
        if (i mod 7) = 0 then
          sx = 16
          sy = 22
          rechneweg 16, 22
          feld(16, 22) += 1
          if feld(16, 22) > 26 then feld(16, 22) = 23
          stein 16, 22
          sx = 0
          rechne 16, 22
        end if
        if (i mod 15) = 0 then feld(6, 22) = 36 - feld(6, 22) : stein 6, 22
        if i > 2^30 then i = 0
      end if
      taste = inkey
      sleep 1
    loop until taste<>""

  case 7
    erase laser, feld
    for i = 1 to 32: feld(i, 15) = 30: next
    feld(9, 19) = 41 : feld(22, 18) = 39 : feld(23, 22) = 40 : feld(10, 23) = 38
    zeichnefeld 15
    stklein 180, 360, spiegel(27).bild, 2
    stklein 420, 360, spiegel(27).bild, 2
    stklein 180, 420, spiegel(27).bild, 2
    stklein 420, 420, spiegel(27).bild, 2
    color &hffffff : print tab(73); "(7/9)" : print "SPIEGLEIN, SPIEGLEIN, DU MUSST WANDERN"
    print : color &hbbbbbb
    print "Mit der LASER-Version 3.0  hat die Familie der Spielelemente  Zuwachs bekommen."
    print "Das juengste Mitglied der Familie ist der Impulsstein. Dieser kann einen beweg-"
    print "lichen Spiegel oder Stein bis an das andere Ende des Spielfeldes bewegen - wenn"
    print "dazwischen kein Hindernis auftaucht."
    print "Ein geschobener Gegenstand kann entweder  von einem anderen Gegenstand oder von"
    print "der Spielfigur gestoppt werden.  Kommt der Gegenstand bei seiner Reise an einem"
    print "anderen Impulsstein vorbei, dann uebernimmt dieser die Fuehrung und der Reisen-"
    print "de wechselt seine Richtung."
    print "Steine schieben  kostet viel Kraft.  Deswegen kann jeder Impulsstein  immer nur"
    print "einen Stein gleichzeitig schieben. Andere Steine muessen dann warten."
    dim t as double
    t = timer
    i = 0
    do
      if (timer - t) > .01 then
        i += 1
        t = timer
        stklein 179+i, 360, spiegel(27).bild, 2
        stklein 180+i, 360, spiegel(27).bild, 2
        stklein 421-i, 420, spiegel(27).bild, 2
        stklein 420-i, 420, spiegel(27).bild, 2
        if i < 61 then
          stklein 180, 421-i, spiegel(27).bild, 2
          stklein 180, 420-i, spiegel(27).bild, 2
          stklein 420, 359+i, spiegel(27).bild, 2
          stklein 420, 360+i, spiegel(27).bild, 2
        end if
        select case i\8 mod 6
          case 0
            stklein 160, 360, spiegel(41).bild, 1
            stklein 420, 340, spiegel(39).bild, 1
            stklein 440, 420, spiegel(40).bild, 1
            stklein 180, 440, spiegel(38).bild, 1
          case 1
            stklein 160, 360, spiegel(41).bild1, 1
            stklein 420, 340, spiegel(39).bild1, 1
            stklein 440, 420, spiegel(40).bild1, 1
            stklein 180, 440, spiegel(38).bild1, 1
          case 2
            stklein 160, 360, spiegel(41).bild2, 1
            stklein 420, 340, spiegel(39).bild2, 1
            stklein 440, 420, spiegel(40).bild2, 1
            stklein 180, 440, spiegel(38).bild2, 1
          case 3
            stklein 160, 360, spiegel(41).bild3, 1
            stklein 420, 340, spiegel(39).bild3, 1
            stklein 440, 420, spiegel(40).bild3, 1
            stklein 180, 440, spiegel(38).bild3, 1
          case 4
            stklein 160, 360, spiegel(41).bild4, 1
            stklein 420, 340, spiegel(39).bild4, 1
            stklein 440, 420, spiegel(40).bild4, 1
            stklein 180, 440, spiegel(38).bild4, 1
        end select
        if i > 239 then i = 0
      end if
      taste = inkey
      sleep 1
    loop until taste<>""

  case 8
    color &hffffff : print tab(73); "(8/9)" : print "EINZEL- UND PARTNERSPIEL"
    print : color &hbbbbbb
    print "Automatische Steine hin oder her - Level loesen sich nicht von selbst. Um deine"
    print "Spielfigur zu bewegen, benutze die Pfeiltasten. Im Zwei-Spieler-Modus verwendet"
    print "der zweite Spieler die Nummerntasten 2, 4, 6 und 8. Beide Spieler verfolgen ge-"
    print "meinsam das Ziel, alle Laserkanonen zu zerstoeren. Stirbt einer der beiden dann"
    print "endet die Runde auch fuer den anderen."
    print "Je schneller ein Level geloest werden kann, desto mehr Punkte gibt es.  Ausser-"
    print "dem gibt es zusaetzliche Punkte fuer jeden getroffenen Diamanten. Die Spielein-"
    print "stellung 'schwer' gibt  mehr Punkte als  die Einstellung 'leicht'.  Dafuer hast"
    print "du zum Loesen des Levels auch weniger Zeit. Und wenn die Zeit abgelaufen ist..."
    print "naja, du weisst schon."
    print "Wenn dir das alles  fuer den Anfang  viel zu hektisch ist,  dann kannst du auch"
    print "die Schwierigkeit 'frei' waehlen. Damit bleibt dir in jedem Level beliebig viel"
    print "Zeit, du bekommst aber auch am wenigsten Punkte."
    print : locate , 53 : print "(bitte eine Taste druecken)"
    do
      sleep 1
      taste = inkey
    loop until taste<>""

  'case 9:
  '  color &hffffff : print tab(73); "(9/10)" : print "AUF IN DIE SCHLACHT"
  '  print : color &hbbbbbb
  '  print "Eine Besonderheit stellt der Schlacht-Modus dar. Hier treten die beiden Spieler"
  '  print "gegeneinander an. Ziel ist es, mehr Punkte zu erreichen als der Gegner."
  '  print "Punkte gibt es fuer drei verschiedene Dinge: zerstoerte Laser, getoetete Gegner"
  '  print "und getroffene Diamanten.  Es lohnt sich, speziell in einem oder zwei Bereichen"
  '  print "moeglichst viele Einzelsiege zu erringen.  Dies gibt naemlich Zusatzpunkte. Hat"
  '  print "Spieler A beispielsweise beim Diamanten-Sammeln 5 Teilsiege errungen, sein Geg-"
  '  print "dagegen nur 4, dann erhaelt Spieler A (zusaetzlich zu den anderen Punkten) noch"
  '  print "einen weiteren Punkt in der Kategorie 'Diamanten'.  Wenn Spieler A aber 8 Teil-"
  '  print "siege erreicht und sein Gegner nur 2, dann werden Spieler A die stolze Zahl von"
  '  print "36 Zusatzpunkten gutgeschrieben."
  '  print "Eine weitere Besonderheit ist die Zahl der verfuegbaren Figuren.  Jeder Spieler"
  '  print "kann mehrere Spielfiguren besitzen,  zwischen denen er jederzeit wechseln kann."
  '  print "Spieler 1 verwendet zum Wechseln die Tabulatortaste, Spieler 2 die ENTER-Taste."
  '  print "Eine Runde endet,  sobald alle Laserkanonen zerstoert sind oder sobald die Zeit"
  '  print "abgelaufen ist."
  '  print : locate , 53: print "(bitte eine Taste druecken)"
  '  do
  '    sleep 1
  '    taste = inkey
  '  loop until taste<>""

  case 9
    color &hffffff : print tab(73); "(9/9)" : print "ZU GUTER LETZT"
    print : color &hbbbbbb
    print "Sollte dir das Spiel gefallen oder hast du Anregungen dazu, dann kannst du gern"
    print "dem Autor eine E-Mail an die Adresse programmierung@eulengesang.de schicken."
    print "Vielleicht willst du dich auch selbst als Levelschreiber versuchen. Dann wuerde"
    print "ich mich freuen,  wenn du mir deine Level zuschickst.  Falls sie in das Gesamt-"
    print "konzept passen, werde ich sie gerne in die Originallevel aufnehmen."
    print
    print "Die Hintergrundmusik wurde von Jojo (Saga Musix - http://sagamusix.de) gestal-"
    print "tet.  Herzlichen Dank an ihn und an den Komponisten Timewyrm  fuer die Bereit-"
    print "stellung der Musik."
    print : print "Und nun viel Spass beim Spielen!"
    print : locate , 53: print "(bitte eine Taste druecken)"
    do
      sleep 1
      taste = inkey
    loop until taste<>""
  end select

  if taste = chr(255, 72) or taste = chr(255) & chr(75) then seite -= 1 else seite += 1
  if seite < 1 then seite = 1
  if taste = chr(27) or taste = chr(255) & "k" then exit sub
  loop until seite = 10
end sub

sub bewegen(byval nr as ubyte, byval r as ubyte)
  ' bewegt Mann Nr. nr in Richtung r
  dim as byte bx=0, by=0
  select case r
    case 1 : by = -1
    case 2 : by = 1
    case 4 : bx = -1
    case 8 : bx = 1
  end select
  if feld(mensch(nr).x+bx, mensch(nr).y+by) > 127 then exit sub
  dim as ubyte f = feld(mensch(nr).x+bx, mensch(nr).y+by) and 127
  if (spiegel(f).sicht and 1) = 1 or (spiegel(f).naechster = 0 and _
     (feld(mensch(nr).x+2*bx, mensch(nr).y+2*by) = 0 or feld(mensch(nr).x+2*bx, mensch(nr).y+2*by) = 36)) then
    mensch(nr).bewegdauer = 1
    mensch(nr).bewegx = bx
    mensch(nr).bewegy = by
    if (spiegel(f).sicht and 1)<>1 then
      thread(nr-1) = threadneu(mensch(nr).x+bx, mensch(nr).y+by, 0)
      thread(nr-1).bewegx = bx
      thread(nr-1).bewegy = by
    end if
  elseif spiegel(f).naechster <> 0 and spiegel(f).naechster <> f then
    thread(nr-1) = threadneu(mensch(nr).x+bx, mensch(nr).y+by, 0)
    wartefrei(nr) = r
  end if
end sub

function bildschirm_speichern as any ptr
  dim as any ptr speicher = imagecreate(640, 480)
  get (0, 0)-step(639, 479), speicher
  return speicher
end function

sub bildschirm_zuruecksetzen(byval speicher as any ptr)
  put (0, 0), speicher, pset
  imagedestroy speicher
end sub

sub feldinit(byval set as string, byval nr as ubyte)
  ' laedt, initialisiert und zeichnet das Spielfeld, startet die Laser
  ' Ist set="", dann wird das Spielfeld nicht neu geladen
  dim as ubyte lasx(255), lasy(255), i, k, f, hilfanz = 0
  dim as string z
  erase laser, feld, thread', hilfsmeldung
  if set <> "" then
    laden set, nr
    ' Hilfsmeldungen einlesen
    dim as integer f = freefile
    if open("level/" & set & ".txt" for input as #1) = 0 then
      do
        line input #1, z
        if val(left(z, 2)) = nr then
          hilfanz += 1
          redim preserve hilfsmeldung(1 to hilfanz)
          hilfsmeldung(hilfanz) = z
        end if
      loop until eof(1)
      close #1
    end if
  end if
  AnzahlThreads = 0
  AnzahlLaser = 0
  _MODUS_ += 10 ' erstes zeichnen
  for i=1 to 32 : for k=1 to 24
    if (feld(i, k) and 127) > 0 and (feld(i,k) and 127) < 5 and AnzahlLaser < 100 then
      AnzahlLaser += 1
      lasx(AnzahlLaser) = i
      lasy(AnzahlLaser) = k
    end if
    if feld(i, k) = 5 then mensch(1).x = i : mensch(1).y = k : feld(i, k) = 0
    if feld(i, k) > 255 and spiegel(feld(i,k) and 127).dreh <> 3 andalso AnzahlThreads < 600 then
      AnzahlThreads += 1
      thread(AnzahlThreads) = threadneu(i, k, feld(i, k) shr 8)
    end if
    if feld(i, k) > 37 and feld(i, k) < 42 and AnzahlThreads < 600 then ' IMPULSSTEIN
      AnzahlThreads += 2
      thread(AnzahlThreads-1) = threadneu(i, k, 5)
      thread(AnzahlThreads-1).sonder = 1
      thread(AnzahlThreads).sonder = 2
      select case feld(i, k)
        case 38 : thread(AnzahlThreads-1).bewegy = -1
        case 39 : thread(AnzahlThreads-1).bewegy = 1
        case 40 : thread(AnzahlThreads-1).bewegx = -1
        case 41 : thread(AnzahlThreads-1).bewegx = 1
      end select
    end if
    stein i, k
  next : next

  _MODUS_ -= 10
  mensch(1).aktuellbild = mensch(1).bild(1, 0)
  stklein mensch(1).x*20-20, mensch(1).y*20-20, mensch(1).aktuellbild,2
  for i = 1 to AnzahlLaser
    f = feld(lasx(i),lasy(i))
    select case f
      case 1
        rechne lasx(i), lasy(i)-1, 1
        laser(lasx(i), lasy(i)) or= 1 ' wird benoetigt, um den Laser wieder korrekt zu loeschen
      case 2
        rechne lasx(i), lasy(i)+1, 2
        laser(lasx(i), lasy(i)) or= 2
      case 3
        rechne lasx(i)-1, lasy(i), 4
        laser(lasx(i), lasy(i)) or= 4
      case 4
        rechne lasx(i)+1, lasy(i), 8
        laser(lasx(i), lasy(i)) or= 8
    end select
    feld(lasx(i),lasy(i)) = f
  next

  if leben > 0 then
    for i = 1 to leben-1
      stklein(i*30-10, 20, mensch(1).bild(0,2), 2)
    next
  end if
  select case modus
    case " frei " : zeit = 1
    case "leicht" : zeit *= 2
    case "mittel" : zeit *= 1.5
    case "schwer"
  end select

  color &hffffff
  locate 2, 30 : print "Punkte: " & punkte
  locate 2, 50 : print "Zeit: " & zeit
  ' Menschbewegungen des Vorlevels beenden
  mensch(1).bewegdauer = 0
  mensch(2).bewegdauer = 0
end sub

function font_laden(byval datei as string) as any ptr
  Dim As Integer breit, p, i
  dim bild as any ptr = pload(datei), ret as ubyte ptr = pload(datei)
  ret[32] = 0
  ret[33] = 32
  ret[34] = 127
  for i = 0 to 95
    ret[35 + i] = 9
  next
  put ret, (0, 1), bild, (0, 0) - (8, 16), or
  imagedestroy bild
  return ret
end function

sub ladeinfo(byval set as string, byref typ as ubyte, byref kommentar as string, _
             byref autor as string, byref version as ushort)
  ' laedt die Informationen eines Levelsets
  dim suchpunkt as uinteger, i as ubyte, k as ubyte, nr as ubyte
  dim kom as string*255, aut as string*63
  dim spversion as ushort
  open "level/" & set for binary as #1
  get #1,, spversion
  get #1,, levanz
  seek 1, 1024
  get #1,, typ
  get #1,, kom
  kommentar = kom
  get #1,, aut
  autor = aut
  get #1,, version
  close 1
end sub

sub laden(byval set as string, byval nr as ubyte = 0)
  'Laedt Level nr aus dem Set level/set
  'ACHTUNG: nr = 0 funktioniert nur bei Ein-Level-"Sets"
  dim i as ubyte, k as ubyte, z as ushort, suchpunkt as ushort
  if dir("level/" & set) = "" then exit sub
  open "level/" & set for binary as #1
  if nr = 0 then
    seek 1, 3
  else
    seek 1, 4*nr+1
    get #1,, suchpunkt
    seek 1, suchpunkt
  end if
  get #1,, zeit
  for k = 4 to 25
    feld(0, k)  = 30
    feld(33, k) = 30
    editorfeld(0, k, 0)  = 30
    editorfeld(33, k, 0) = 30
  next
  for i = 1 to 32
    feld(i, 4)  = 30
    feld(i, 25) = 30
    editorfeld(i, 4, 0)  = 30
    editorfeld(i, 25, 0) = 30
    for k = 5 to 24
      get #1,, feld(i, k)
      editorfeld(i, k, 0) = feld(i, k)
    next
  next
  close #1
end sub

function lasertest(byval x as ubyte, byval y as ubyte, byval r as ubyte) as ubyte
  ' testet, ob ein Laserstrahl von Feld x/y in Richtung r laeuft
  dim as ubyte richtungneu
  if laser(x,y) and 1 then richtungneu = spiegel(feld(x, y) and 127).reflekto
  if laser(x,y) and 2 then richtungneu = richtungneu or spiegel(feld(x, y) and 127).reflektu
  if laser(x,y) and 4 then richtungneu = richtungneu or spiegel(feld(x, y) and 127).reflektl
  if laser(x,y) and 8 then richtungneu = richtungneu or spiegel(feld(x, y) and 127).reflektr
  return richtungneu and r
end function

sub loeschen(byval set as string, byval nr as ubyte)
  ' loescht das Level nr aus dem set level/set
  if nr = 0 or nr > levanz or levanz = 1 then exit sub
  if dir("level/" & set) = "" then exit sub
  dim as uinteger temp
  open "level/" & set for binary as #1
  for i as ubyte = nr to levanz-1
    seek 1, 4*i+5
    get #1,, temp
    seek 1, 4*i+1
    put #1,, temp
  next
  levanz -= 1
  seek 1, 3
  put #1,, levanz
  close #1
  reorganisation(set)
end sub

sub meldung(byval text as string)
  ' gibt eine Meldung mit bis zu 5 Zeilen aus
  ' Der erste Leerstring begrenzt die Groesse des Rahmens!
  dim textzahl as byte, such as short, textlaenge as short, txt(1 to 5) as string
  txt(1) = text
  ' Text auseinandernehmen
  for textzahl = 1 to 4
    such = instr(txt(textzahl), "\n")
    if such > 0 then
      txt(textzahl+1) = mid(txt(textzahl), such+2)
      txt(textzahl) = left(txt(textzahl), such-1)
      if textlaenge < such-1 then textlaenge = such-1
    else
      exit for
    end if
  next
  if textlaenge < len(txt(textzahl)) then textlaenge = len(txt(textzahl))
  dim as ubyte minx=15-textlaenge*0.225, maxx=18+textlaenge*0.225, miny=14-(textzahl+1)\2, maxy=15+textzahl\2
  for i as ubyte = minx-1 to maxx+1
    for k as ubyte = miny-1 to maxy+1
      if (i = minx or i = maxx) and k >= miny and k <= maxy or _
         (k = miny or k = maxy) and i >= minx and i <= maxx then
        stein i, k, 30
      else
        stein i, k, 0
      end if
    next
  next
  for i as ubyte = 1 to textzahl
    draw string (320-4.5*len(txt(i)), miny*20+i*20-16), txt(i),, font, pset
  next
end sub

function pload(byval datei as string) as any ptr
  dim ret as any ptr
  dim as integer breit, hoch, ff
  ff = freefile
  open datei for input as #ff
  get #ff, 19, breit
  get #ff, 23, hoch
  close #ff
  ret = imagecreate(breit, hoch)
  bload datei, ret
  return ret
end function

sub quicksort(array() as string, byval start as ubyte = 0, byval ende as ubyte = 254)
  if start = 0 then start = lbound(array)
  if ende = 255 then ende = ubound(array)
  dim as ubyte i = start, j = ende
  dim as string mitte = lcase(array((i+j)\2))
  do
    while lcase(array(i)) < mitte : i += 1 : wend
    while lcase(array(j)) > mitte : j -= 1 : wend
    if i <= j then
      swap array(i), array(j)
      i += 1
      j -= 1
    end if
  loop until i > j
  if j > start then quicksort(array(), start, j)
  if i < ende then quicksort(array(), i, ende)
end sub

sub rechne(byval x as ubyte, byval y as ubyte, byval r as ubyte = 0)
  ' r=0: Laser-Berechnung, wobei x/y bereits das erste berechnete Feld ist
  ' sonst: berechnet den Laserstrahl ab Feld x/y in Richtung r
  ' r = +1:oben; +2:unten; +4:links; +8:rechts
  if r = 0 then
    zeichnemensch
    if x<1 or x>32 or y<1 or y>24 then exit sub
    if lasertest(x, y+1, 1) then rechne x, y, 1
    if lasertest(x, y-1, 2) then rechne x, y, 2
    if lasertest(x+1, y, 4) then rechne x, y, 4
    if lasertest(x-1, y, 8) then rechne x, y, 8
    zeichnemensch
  else
    if x < 1 or x > 32 or y < 1 or y > 24 or r = 0 then exit sub
    dim as ubyte neu_r = 0
    if ((feld(x, y) > 0 and feld(x, y) < 5) _
       or (feld(x, y) and 127) = 34) then                         ' etwas Zerbrechliches getroffen
      if sound and SOUND_EFFEKT_AN then sound_spielen(sound_bruch)
      AnzahlThreads += 1
      if feld(x, y) < 5 then
        select case modus
          case " frei " : punkte += 10
          case "leicht" : punkte += 10 : zeit += 20
          case "mittel" : punkte += 20 : zeit += 15
          case "schwer" : punkte += 50 : zeit += 10
        end select
      end if
      if feld(x,y) = 34 then punkte += 5 : feld(x, y) = 6
      thread(AnzahlThreads) = threadneu(x, y, 0)
      thread(AnzahlThreads).sonder = 3
      locate 2, 30 : print "Punkte: " & punkte
    elseif (feld(x, y) and 127) = 42 then                         ' Info-Feld getroffen
      AnzahlThreads += 1
      thread(AnzahlThreads) = threadneu(x, y, feld(x,y) \ 256)
      thread(AnzahlThreads).sonder = 4
    end if
    if feld(x, y) = 37 then
      feld(x, y) = 7
      stein x, y
      if _MODUS_ <> 2 then
        select case modus
          case " frei " : punkte += 50
          case "leicht" : punkte += 75
          case "mittel" : punkte += 120
          case "schwer" : punkte += 200
        end select
        locate 2, 30 : print "Punkte: " & punkte
      end if
    end if
    with spiegel(feld(x, y) and 127)
      select case r
      case 1
        if .reflekto <> 0 then
          if (.sicht and 4) = 4 and (laser(x,y) and 3) = 0 then line (x*20-11,y*20-20)-step(0,19),&hff0000
          if (laser(x,y) and 1)=0 then
            laser(x,y) = laser(x,y) or 1
            neu_r = .reflekto
          end if
        end if
      case 2
        if .reflektu <> 0 then
          if (.sicht and 4) = 4 and (laser(x,y) and 3) = 0 then line (x*20-11,y*20-20)-step(0,19),&hff0000
          if (laser(x,y) and 2)=0 then
            laser(x,y) = laser(x,y) or 2
            neu_r = .reflektu
          end if
        end if
      case 4
        if .reflektl <> 0 then
          if (.sicht and 2) = 2 and (laser(x,y) and 12) = 0 then line (x*20-20,y*20-11)-step(19,0),&hff0000
          if (laser(x,y) and 4)=0 then
            laser(x,y) = laser(x,y) or 4
            neu_r = .reflektl
          end if
        end if
      case 8
        if .reflektr <> 0 then
          if (.sicht and 2) = 2 and (laser(x,y) and 12) = 0 then line (x*20-20,y*20-11)-step(19,0),&hff0000
          if (laser(x,y) and 8)=0 then
            laser(x,y) = laser(x,y) or 8
            neu_r = .reflektr
          end if
        end if
      end select
    end with
    ' berechne rekursiv weiter
    if neu_r and 1 then rechne x, y-1, 1
    if neu_r and 2 then rechne x, y+1, 2
    if neu_r and 4 then rechne x-1, y, 4
    if neu_r and 8 then rechne x+1, y, 8
  end if
end sub

sub rechneweg (byval x as ubyte, byval y as ubyte, byval r as ubyte = 0, byval opt as ubyte = 0)
  ' loescht den Laserstrahl ab Feld x/y in Richtung r
  ' r = +1:oben; +2:unten; +4:links; +8:rechts; 0:alles pruefen
  ' opt = 1: wird beim Verschieben eines Steines benoetigt
  dim as ubyte f, xn=x, yn=y, rn, rest
  if x < 1 or x > 32 or y < 1 or y > 24 then exit sub
  if r = 0 then
    AnzahlZurueck = 0   ' Rueckrechnung zuruecksetzen
    zeichnemensch
    f = feld(x, y)
    if opt = 1 then
      rn = lasertest(x, y, 15)
      feld(x, y) = 0
      if rn and 1 then rechneweg x, y, 1
      if rn and 2 then rechneweg x, y, 2
      if rn and 4 then rechneweg x, y, 4
      if rn and 8 then rechneweg x, y, 8
    else
      if lasertest(x, y+1, 1) then rechneweg x, y, 1
      if lasertest(x, y-1, 2) then rechneweg x, y, 2
      if lasertest(x+1, y, 4) then rechneweg x, y, 4
      if lasertest(x-1, y, 8) then rechneweg x, y, 8
    end if
    feld(x, y) = f
    ' Rueckrechung
    zeichnemensch
  else
    if (laser(x, y) and 15) = 0 then exit sub
    f = feld(x, y) and 127
    ' berechne die neue Richtung des Lasers
    select case r
      case 1 : rn = spiegel(f).reflekto
      case 2 : rn = spiegel(f).reflektu
      case 4 : rn = spiegel(f).reflektl
      case 8 : rn = spiegel(f).reflektr
    end select
    laser(x, y) = laser(x, y) and (not r)
    ' berechne rekursiv weiter
    if rn and 1 then
      rechneweg x, y-1, 1
      'if lasertest(x, y, 1) then rechne x, y-1, 1
    end if
    if rn and 2 then
      rechneweg x, y+1, 2
      'if lasertest(x, y, 2) then rechne x, y+1, 2
    end if
    if rn and 4 then
      rechneweg x-1, y, 4
      'if lasertest(x, y, 4) then rechne x-1, y, 4
    end if
    if rn and 8 then
      rechneweg x+1, y, 8
      'if lasertest(x, y, 8) then rechne x+1, y, 8
    end if
    ' merken, falls Feld noch eine weitere Laserquelle besitzt
    if lasertest(x, y, 15) then
      AnzahlZurueck += 1
      zurueck(AnzahlZurueck).x = x
      zurueck(AnzahlZurueck).y = y
    end if

    ' graphische Darstellung
    if feld(x, y) < 256 then stein x, y
    if (laser(x, y) and 3) <> 0 and (spiegel(f).sicht and 4) = 4 then
      line (x*20-11,y*20-20)-step(0,19),&hff0000
    end if
    if (laser(x, y) and 12) <> 0 and (spiegel(f).sicht and 2) = 2 then
      line (x*20-20,y*20-11)-step(19,0),&hff0000
    end if
  end if
end sub

sub rechneweg_abschluss
  for i as short = 1 to AnzahlZurueck
    with zurueck(i)
      if lasertest(.x, .y, 1) then rechne .x, .y-1, 1
      if lasertest(.x, .y, 2) then rechne .x, .y+1, 2
      if lasertest(.x, .y, 4) then rechne .x-1, .y, 4
      if lasertest(.x, .y, 8) then rechne .x+1, .y, 8
    end with
  next
end sub

sub reorganisation(byval set as string)
  dim as ushort daten(255, 32, 24), version
  dim as ubyte typ, i, k, j
  dim as uinteger suchpunkt
  dim kommentar as string*255, autor as string*63
  ' alle Daten laden
  ladeinfo(set, typ, kommentar, autor, version)
  daten(0, 0, 0) = levanz
  for i = 1 to levanz
    laden set, i
    daten(i, 0, 0) = zeit
    for k=1 to 32 : for j = 5 to 24
      daten(i, k, j) = feld(k, j)
    next : next
  next
  ' alle Daten speichern
  kill "level/" & set
  open "level/" & set for binary as #1
  put #1,, speicherversion
  put #1,, levanz
  seek 1, 1024
  put #1,, typ
  put #1,, kommentar
  put #1,, autor
  put #1,, version
  for i = 1 to levanz
    suchpunkt = seek(1)
    put #1, 4*i+1, suchpunkt
    put #1, suchpunkt, daten(i, 0, 0)
    for k = 1 to 32 : for j = 5 to 24
      put #1, , daten(i, k, j)
    next : next
  next
  close 1
end sub

function sound_laden(byval datei as string) as uinteger
  #ifdef SND
    if sound and SOUND_EFFEKT_OK = 0 then return 0
    dim as uinteger ret = BASS_SampleLoad(0, strptr(datei), 0, 0, 16, 0)
    if ret = 0 then print "BASS: Sound '" & datei & "' konnte nicht initialisiert werden!" : getkey
    return ret
  #else
    return 0
  #endif
end function

sub sound_spielen(byval sound as uinteger)
  #ifdef SND
    dim channel as HCHANNEL = BASS_SampleGetChannel(sound, 0)
    BASS_ChannelSetAttribute(channel, BASS_ATTRIB_VOL, 1)
    BASS_ChannelSetAttribute(channel, BASS_ATTRIB_PAN, 0)
    BASS_ChannelPlay(channel, 0)
  #endif
end sub

sub speichereinfo(byval set as string, byval typ as ubyte, byval kommentar as string, _
                  byval autor as string, byval version as ushort)
  ' speichert die Informationen eines Levelsets
  dim suchpunkt as uinteger, i as ubyte, k as ubyte, nr as ubyte
  dim kom as string*255, aut as string*63
  kom = kommentar
  aut = autor
  dim speicherversion as ushort
  open "level/" & set for binary as #1
  put #1,, speicherversion
  put #1,, levanz
  seek 1, 1024
  put #1,, typ
  put #1,, kom
  put #1,, aut
  put #1,, version
  close 1
end sub

sub speichern(byval set as string, byval nr as ubyte = 0)
  'Speichert Level nr in das Set level/set
  'ACHTUNG: nr = 0 funktioniert nur bei Ein-Level-"Sets"
  dim i as ubyte, k as ubyte, z as ushort, suchpunkt as ushort
  open "level/" & set for binary as #1
  seek 1, 3
  if nr <> 0 then
    if nr > levanz then
      levanz = nr
      put #1,, levanz
      seek 1, 4*nr+1
      put #1,, nr*1282+63
      seek 1, nr*1282+63
    else
      seek 1, 4*nr+1
      get #1,, suchpunkt
      seek 1, suchpunkt
    end if
  end if
  put #1,, zeit
  for i = 1 to 32
    for k = 5 to 24
      put #1,, editorfeld(i, k, 0)
    next
  next
  close #1
end sub

function spiel(byval set as string, byval nr as ubyte) as TypSpielergebnis
  ' spielt Level nr aus dem Set set und gibt das Ergebnis zurueck
  dim as ubyte i, k, bewegr, f, zeitzaehler
  dim ret as TypSpielergebnis, t as double, taste as string, bild as any ptr
  dim DEBUGZAEHLER as ubyte, DEBUGMAX as single, schnell as single, speicher as any ptr
  cls
  ' Initialisierung des Spielfeldes
  feldinit(set, nr)
  select case modus
    case " frei ", "leicht" : schnell = 0.021
    case "mittel" : schnell = 0.018
    case "schwer" : schnell = 0.015
  end select
  if _MODUS_ = 10 then modus = "schwer" : zeit = 0

  'warte auf Tastendruck vor dem Start
  do : sleep 1: loop until inkey = ""
  do
    getjoystick 0, js_b1, js_x1, js_y1
    getjoystick 1, js_b2, js_x2, js_y2
    if js_b1 <> -1 andalso js_b1 > 0 or abs(js_x1) >= js_e1 or abs(js_y1) >= js_e1 then exit do
    if js_b2 <> -1 andalso js_b2 > 0 or abs(js_x2) >= js_e2 or abs(js_x2) >= js_e2 then exit do
    sleep 1
  loop until inkey <> ""

  ' Spiel starten
  do
    t = timer
    getjoystick 0, js_b1, js_x1, js_y1
    getjoystick 1, js_b2, js_x2, js_y2
    ' Menschen bewegen
    for i=1 to 2
      select case wartefrei(i)
        case 0 ' nichts tun
        case 1
          if (multikey(B_O) and SteuerungAdws=i) or (multikey(Z_O) and Steuerung4682=i) _
             or (js_y1<=-js_e1 and SteuerungJoy1=i) or (js_y2<=-js_e2 and SteuerungJoy2=i) _
             or (multikey(P_O) and SteuerungPfeil=i) then continue for
        case 2
          if (multikey(B_U) and SteuerungAdws=i) or ((multikey(Z_U) or multikey(Z_M)) and Steuerung4682=i) _
             or (js_y1>=js_e1 and SteuerungJoy1=i) or (js_y2>=js_e2 and SteuerungJoy2=i) _
             or (multikey(P_U) and SteuerungPfeil=i) then continue for
        case 4
          if (multikey(B_L) and SteuerungAdws=i) or (multikey(Z_L) and Steuerung4682=i) _
             or (js_x1<=-js_e1 and SteuerungJoy1=i) or (js_x2<=-js_e2 and SteuerungJoy2=i) _
             or (multikey(P_L) and SteuerungPfeil=i) then continue for
        case 8
          if (multikey(B_R) and SteuerungAdws=i) or (multikey(Z_R) and Steuerung4682=i) _
             or (js_x1>=js_e1 and SteuerungJoy1=i) or (js_x2>=js_e2 and SteuerungJoy2=i) _
             or (multikey(P_R) and SteuerungPfeil=i) then continue for
      end select
      wartefrei(i) = 0
      if mensch(i).bewegdauer = 0 then     ' Mensch steht gerade still
        if (multikey(B_O) and SteuerungAdws=i) or (multikey(Z_O) and Steuerung4682=i) _
          or (js_y1<=-js_e1 and SteuerungJoy1=i) or (js_y2<=-js_e2 and SteuerungJoy2=i) _
          or (multikey(P_O) and SteuerungPfeil=i) then
          bewegen(i, 1)
        elseif (multikey(B_U) and SteuerungAdws=i) or ((multikey(Z_U) _
          or multikey(Z_M)) and Steuerung4682=i) _
          or (js_y1>=js_e1 and SteuerungJoy1=i) or (js_y2>=js_e2 and SteuerungJoy2=i) _
          or (multikey(P_U) and SteuerungPfeil=i) then
          bewegen(i, 2)
        elseif (multikey(B_L) and SteuerungAdws=i) or (multikey(Z_L) and Steuerung4682=i) _
          or (js_x1<=-js_e1 and SteuerungJoy1=i) or (js_x2<=-js_e2 and SteuerungJoy2=i) _
          or (multikey(P_L) and SteuerungPfeil=i) then
          bewegen(i, 4)
        elseif (multikey(B_R) and SteuerungAdws=i) or (multikey(Z_R) and Steuerung4682=i) _
          or (js_x1>=js_e1 and SteuerungJoy1=i) or (js_x2>=js_e2 and SteuerungJoy2=i) _
          or (multikey(P_R) and SteuerungPfeil=i) then
          bewegen(i, 8)
        end if
      else                               ' Mensch bewegt sich gerade
        if mensch(i).x <> 0 or mensch(i).y <> 0 then
          bewegr = (3*mensch(i).bewegy^2+mensch(i).bewegy)\2 + (7*mensch(i).bewegx^2+mensch(i).bewegx)\2
          stklein mensch(i).x*20+mensch(i).bewegx*(mensch(i).bewegdauer-1)*2-20, _
                  mensch(i).y*20+mensch(i).bewegy*(mensch(i).bewegdauer-1)*2-20, mensch(i).aktuellbild, 2
          select case mensch(i).bewegdauer
            case 5,10 : mensch(i).aktuellbild = mensch(i).bild(bewegr, 0)
            case 1, 4 : mensch(i).aktuellbild = mensch(i).bild(bewegr, 1)
            case 2, 3 : mensch(i).aktuellbild = mensch(i).bild(bewegr, 2)
            case 6, 9 : mensch(i).aktuellbild = mensch(i).bild(bewegr, 3)
            case 7, 8 : mensch(i).aktuellbild = mensch(i).bild(bewegr, 4)
          end select
          stklein mensch(i).x*20+mensch(i).bewegx*mensch(i).bewegdauer*2-20, _
                  mensch(i).y*20+mensch(i).bewegy*mensch(i).bewegdauer*2-20, mensch(i).aktuellbild, 2
        end if
        mensch(i).bewegdauer += 1
        if mensch(i).bewegdauer > 10 then
          mensch(i).x += mensch(i).bewegx
          mensch(i).y += mensch(i).bewegy
          mensch(i).bewegdauer = 0
          mensch(i).bewegx = 0
          mensch(i).bewegy = 0
        end if
      end if
    next
    ' Threads abarbeiten
    for i as ushort = 0 to AnzahlThreads : threadstart i : next
    ' Zeit weiterzaehlen
    zeitzaehler += 1
    if zeitzaehler > 49 then
      zeitzaehler = 0
      if modus <> " frei " then zeit -= 1
      color &hffffff
      locate 2, 50 : print "Zeit: " & zeit & " "
    end if

  ' ***** TIME-DEBUGGING *****
    if DEBUG then
      DEBUGZAEHLER += 1
      if DEBUGMAX < timer-t then DEBUGMAX = timer-t
      if DEBUGZAEHLER = 50 then
        color &hffffff
        locate 1,50 : print "Laser: " & AnzahlLaser
        locate 1,60 : print using "AUSLASTUNG:####.##%"; DEBUGMAX*5000
        locate 2,60 : print "Threads: "; AnzahlThreads ; "  "
        DEBUGMAX = 0
        DEBUGZAEHLER = 0
      end if
    end if
  ' **************************

    ' EXIT-Bedingungen
    if (laser(mensch(1).x,mensch(1).y)<>0 or feld(mensch(1).x,mensch(1).y)=36) and mensch(1).bewegdauer=0 then
      ret.typ = 2  ' Mensch 1 stirbt
      ret.leben = 1
    end if
    if (laser(mensch(2).x,mensch(2).y)<>0 or feld(mensch(2).x,mensch(2).y)=36) and mensch(2).bewegdauer=0 then
      ret.typ = 3  ' Mensch 2 stirbt
      ret.leben = -1
    end if
    if AnzahlLaser = 0 then
      ret.typ = 1  ' Spielgewinn
    end if
    if multikey(78) then
      ret.typ = 9  ' +: ein Level weiter
    end if
    if multikey(12) then
      ret.typ = 10 ' -: ein Level zurueck
    end if
    if multikey(1) then
      ret.typ = 11 ' ESC: Spielabbruch
      ret.leben = 127
    end if
    if multikey(25) and DEBUG then ' Pause einlegen
      getkey
      t = timer
    end if
    if multikey(44) and DEBUG and zeit < 100 then ' Zeitbonus
      zeit += 100
    end if
    if multikey(38) and DEBUG then ' Laserstrahl debuggen
      do : loop until inkey = ""
      speicher = bildschirm_speichern
      for i=1 to 32 : for k=5 to 24
        draw string (i*20-16, k*20-16), str(laser(i, k))
      next : next
      getkey
      bildschirm_zuruecksetzen(speicher)
      t = timer
    end if
    if multikey(33) and DEBUG then ' Feldnummern debuggen
      do : loop until inkey = ""
      speicher = bildschirm_speichern
      for i=1 to 32 : for k=5 to 24
        draw string (i*20-16, k*20-16), str(feld(i, k))
      next : next
      getkey
      bildschirm_zuruecksetzen(speicher)
      t = timer
    end if
    if multikey(15) and DEBUG then ' Threads debuggen
      do : loop until inkey = ""
      speicher = bildschirm_speichern
      cls
      for i as ushort = 0 to AnzahlThreads
        with thread(i)
          print "(" & .x & "/" & .y & ") Dauer: " & .dauer & ", Art: " & .sonder & ", Stein: " & .nr
        end with
        if (i mod 28) = 27 or i=AnzahlThreads then
          getkey
          cls
        end if
      next
      bildschirm_zuruecksetzen(speicher)
      t = timer
    end if
    do
      taste = inkey
      sleep 1
    loop until timer - t > schnell or taste = chr(255) & "k"
    if taste = chr(255) & "k" then ret.typ = 12
    if zeit < 1 and _MODUS_ < 10 then ret.typ = 2 : ret.leben = 1
  loop until ret.typ > 0
  select case ret.typ
  case 1        ' normaler Gewinn
    meldung "Level abgeschlossen!\n\nDruecke die Leertaste,\num fortzufahren."
    taste = ""
    for i as short = zeit-1 to 0 step -1
      locate 2, 50 : print "Zeit: " & i & " "
      select case modus
        case "leicht" : punkte += 1
        case "mittel" : punkte += 2
        case "schwer" : punkte += 5
      end select
      locate 2, 30 : print "Punkte: " & punkte
      if taste <> " " then
        taste = inkey
        sleep 10
      end if
    next
    do while not taste = " "
      taste = inkey
	  sleep 1
	loop
  case 2, 3     ' Leben verloren
    if zeit < 1 and _MODUS_ < 10 then
      meldung "Die Zeit ist um!\n\nDruecke die Leertaste, um fortzufahren."
    else
      meldung "Autsch ...\n\nDruecke die Leertaste, um fortzufahren."
    end if
    do while not taste = " "
      taste = inkey
	  sleep 1
	loop
  end select
  return ret
end function

sub stein(byval x as ubyte, byval y as ubyte, byval nr as ushort = 255, byval stellung as ubyte = 255)
  if nr = 255 then nr = feld(x, y)
  if _MODUS_ mod 10 = 0 and nr = 0 and y < 5 then exit sub
  if (nr and 127) > AnzahlSpiegel then nr = AnzahlSpiegel + 1 ' Fehlerbild
  select case stellung
    case 0, 255 : stklein x*20-20, y*20-20, spiegel(nr and 127).bild, 1
    case 1 : stklein x*20-20, y*20-20, spiegel(nr and 127).bild1, 1
    case 2 : stklein x*20-20, y*20-20, spiegel(nr and 127).bild2, 1
    case 3 : stklein x*20-20, y*20-20, spiegel(nr and 127).bild3, 1
    case 4 : stklein x*20-20, y*20-20, spiegel(nr and 127).bild4, 1
  end select
  if _MODUS_=1 and nr=0 and (y>4 or (x=1 and y=1)) then ' Leerfelder im Editor
    color &hffffff
    line (x*20-11, y*20-13)-step(0, 4)
    line (x*20-13, y*20-11)-step(4, 0)
  end if
  if _MODUS_ > 0 and nr > 255 and spiegel(nr and 127).dreh <> 3 then
    ' Timerzeichen im Editor und beim ersten Zeichnen
    color &hffff00
    line (x*20-6, y*20-19)-step(4, 0)
    line (x*20-4, y*20-18)-step(0, 2)
  end if
end sub

sub stklein(byval x as ushort, byval y as ushort, byval bild as any ptr, byval gfxmod as ubyte)
  ' zeichnet das Bild bild pixelgenau an die Stelle x/y
  ' Modus: 1:transparent; 2:XOR
  select case gfxmod
  case 1
    put (x, y), spiegel(0).bild, pset
    put (x, y), bild, alpha
  case 2
    put (x, y), bild, xor
  end select
end sub

function threadneu(byval x as ubyte, byval y as ubyte, byval dauer as ubyte) as TypThread
  ' definiert einen neuen Thread
  dim as TypThread ret
  ret.x = x
  ret.y = y
  ret.dauer = dauer
  ret.zaehl = 4
  ret.nr = feld(x, y)
  ret.sonder = 0
  return ret
end function

sub threadloeschen(byref thread as TypThread)
  ' gibt einen leeren Thread zurueck
  thread.zaehl = 0
  thread.x = 0
  thread.y = 0
  thread.dauer = 0
  thread.bewegx = 0
  thread.bewegy = 0
  thread.nr = 0
  if thread.sonder <> 2 then thread.sonder = 0
end sub

sub threadstart(byval nr as ushort)
  ' arbeitet thread(nr) ab
  dim as ubyte f, i
  with thread(nr)
    if .sonder = 4 then                                ' Info-Stein
      dim as any ptr speicher
      for i as integer = 1 to ubound(hilfsmeldung)
        if val(mid(hilfsmeldung(i), 4, 2)) = .dauer then
          speicher = bildschirm_speichern
          do : sleep 1 : loop until not multikey(57)
          meldung mid(hilfsmeldung(i), 7)
          do : sleep 1 : loop until multikey(57)
          bildschirm_zuruecksetzen speicher
        end if
      next
      feld(.x, .y) = 30
      stein .x, .y
      threadloeschen(thread(nr))
    elseif (.bewegx<>0 or .bewegy<>0) and .sonder<>1 then  ' geschobener Stein
      if feld(.x, .y) = 36 then
        threadloeschen(thread(nr))
        exit sub
      end if
      if .zaehl <> 0 then
        if .zaehl = 4 then ' (Start)
          f = feld(.x+.bewegx, .y+.bewegy)
          if f<>0 and f<>36 then
            threadloeschen(thread(nr))
            exit sub
          end if
          for i = 1 to 2
            ' Mensch blockiert automatisch geschobenen Stein
            if (mensch(i).x=.x+.bewegx and mensch(i).y=.y+.bewegy) or _
               (mensch(i).x+mensch(i).bewegx=.x+.bewegx and mensch(i).y+mensch(i).bewegy=.y+.bewegy) then
              threadloeschen(thread(nr))
              exit sub
            end if
            ' automatisch geschobener Stein wird vom Menschen weggeschoben
            if i-1 <> nr and .x = thread(i-1).x and .y = thread(i-1).y then
              threadloeschen(thread(nr))
              exit sub
            end if
          next
          stein .x, .y, 0
          stklein .x*20-20, .y*20-20, spiegel(.nr).bild, 2
          feld(.x+.bewegx,.y+.bewegy) or= 128
          feld(.x, .y) or= 128
        end if
        stklein .x*20 - 20 + .bewegx*(.zaehl-4), .y*20 - 20 + .bewegy*(.zaehl-4), spiegel(.nr).bild, 2
        .zaehl += 2
        stklein .x*20 - 20 + .bewegx*(.zaehl-4), .y*20 - 20 + .bewegy*(.zaehl-4), spiegel(.nr).bild, 2
        if .zaehl >= 24 then
          feld(.x, .y) = .nr
          f = feld(.x+.bewegx, .y+.bewegy)
          feld(.x+.bewegx, .y+.bewegy) = 0
          rechneweg .x, .y,, 1
          feld(.x, .y) = 0
          laser(.x, .y) and= 15 - (.bewegx^2 * 6 - .bewegx * 2 + .bewegy^2 * 1.5 - .bewegy * .5)
          rechneweg_abschluss
          zeichnemensch : stein .x, .y : zeichnemensch
          if (f and 127) = 36 then
            if .nr < 27 or .nr > 29 then  ' Spiegel faellt ins Loch
              .nr = f
            else                          ' Stein stopft Loch
              .nr = 0
              for i = 1 to AnzahlThreads
                if thread(i).x = .x+.bewegx and thread(i).y = .y+.bewegy and _
                   ((thread(i).nr and 127) = 0 or (thread(i).nr and 127) = 36) then
                  threadloeschen(thread(i))
                  exit for
                end if
              next
            end if
          end if
          feld(.x+.bewegx, .y+.bewegy) = .nr+0
          rechne .x, .y
          if .sonder = 2 then
            if laser(.x, .y) and 1 then laser(.x, .y) -= 1 : rechne .x, .y, 1
            if laser(.x, .y) and 2 then laser(.x, .y) -= 2 : rechne .x, .y, 2
            if laser(.x, .y) and 4 then laser(.x, .y) -= 4 : rechne .x, .y, 4
            if laser(.x, .y) and 8 then laser(.x, .y) -= 8 : rechne .x, .y, 8
          end if
          if feld(.x+.bewegx, .y+.bewegy)<>36 then
            feld(.x+.bewegx, .y+.bewegy) = 0
            rechneweg .x+.bewegx, .y+.bewegy,, 1
            feld(.x+.bewegx, .y+.bewegy) = .nr
            rechneweg_abschluss
            rechne .x+.bewegx, .y+.bewegy
          end if
          stein .x+.bewegx, .y+.bewegy
          if (spiegel(.nr).sicht and 4) = 4 and (laser(.x+.bewegx, .y+.bewegy) and 3) > 0 then _
            line ((.x+.bewegx)*20-11, (.y+.bewegy)*20-20)-step(0,19),&hff0000
          if (spiegel(.nr).sicht and 2) = 2 and (laser(.x+.bewegx, .y+.bewegy) and 12) > 0 then _
            line ((.x+.bewegx)*20-20, (.y+.bewegy)*20-11)-step(19,0),&hff0000
          if .sonder<>2 or feld(.x+.bewegx,.y+.bewegy+1)=38 or feld(.x+.bewegx,.y+.bewegy-1)=39 _
             or feld(.x+.bewegx+1,.y+.bewegy)=40 or feld(.x+.bewegx-1,.y+.bewegy)=41 or f=36 then
            threadloeschen(thread(nr))
          else
            .x += .bewegx
            .y += .bewegy
            .zaehl = 4
          end if
        end if
      end if
    elseif .x > 0 then                 ' sich drehender/pulsierender/zerstoerter Stein
      .zaehl += 1
      if .zaehl >= .dauer*12 and .zaehl > 4 then .zaehl = 0
      if .zaehl < 4 then
        if spiegel(feld(.x,.y) and 127).naechster = 0 and feld(.x,.y) <> 36 then
          ' Spiegel steht auf sich oeffnendem Loch
          rechneweg .x, .y
          if feld(.x, .y) > 26 and feld(.x, .y) < 30 then
            feld(.x, .y) = 0
            zeichnemensch
            stein .x, .y
            zeichnemensch
            rechneweg_abschluss
            rechne .x, .y
            threadloeschen(thread(nr))
          else
            feld(.x, .y) = 0
            rechneweg_abschluss
          end if
        end if
         zeichnemensch
        if .sonder = 0 then stein .x, .y, feld(.x, .y), .zaehl+1
        if (laser(.x, .y) and 3) <> 0 and (spiegel(feld(.x, .y) and 127).sicht and 1) = 1 then
          line (.x*20-11,.y*20-20)-step(0,19),&hff0000
        end if
        if (laser(.x, .y) and 12) <> 0 and (spiegel(feld(.x, .y) and 127).sicht and 2) = 2 then
          line (.x*20-20,.y*20-11)-step(19,0),&hff0000
        end if
        zeichnemensch
      end if
      if .sonder = 1 then              ' Impulsstein
        stein .x, .y, feld(.x, .y), ((.zaehl-1)\4 mod 5)
        f = feld(.x+.bewegx,.y+.bewegy)
        if thread(nr+1).bewegx=0 and thread(nr+1).bewegy=0 and f<128 and f<>36 then
          if spiegel(f).naechster=0 then
            thread(nr+1) = threadneu(.x+.bewegx, .y+.bewegy, 0)
            thread(nr+1).bewegx = .bewegx
            thread(nr+1).bewegy = .bewegy
            thread(nr+1).sonder = 2
          end if
        end if
      end if
      if .zaehl = 4 then
        rechneweg .x, .y
        if .sonder = 3 then
          rechneweg .x, .y, 2^(feld(.x, .y) - 1)
          if feld(.x, .y) > 0 and feld(.x, .y) < 5 then  ' zerstoerter Laser
            laser(.x, .y) = 0
            AnzahlLaser -= 1
          end if
          feld(.x, .y) = 0
        else
          if feld(.x, .y) <> spiegel(feld(.x, .y)).naechster then
            if feld(.x, .y)<>0 and feld(.x, .y)<>36 then              ' sich drehender Spiegel
            if sound and SOUND_EFFEKT_AN then sound_spielen(sound_dreh)
            end if
            feld(.x, .y) = spiegel((feld(.x, .y) and 127)).naechster
          end if
        end if
        zeichnemensch
        stein .x, .y
        zeichnemensch
        rechneweg_abschluss
        rechne .x, .y
        if .dauer = 0 then
          threadloeschen(thread(nr))
        end if
      elseif .sonder=3 and feld(.x, .y) = 6 then
        stein .x, .y, 34, .zaehl+1
      end if
    end if
    if nr=AnzahlThreads and .nr=0 and AnzahlThreads>0 and .sonder<>2 then AnzahlThreads-=1
  end with
end sub

sub verschieben(byval set as string, byval nr1 as ubyte, byval nr2 as ubyte)
  ' schiebt im Set level/set das Level nr1 an die Stelle nr2
  if nr1 = 0 or nr2 = 0 or nr1 > levanz or nr2 = levanz or nr1 = nr2 then exit sub
  if dir("level/" & set) = "" then exit sub
  dim as uinteger temp, temp2
  dim as byte richtung
  richtung = sgn(nr2 - nr1)
  open "level/" + set for binary as #1
  seek 1, 4*nr1+1
  get #1,, temp
  for i as short = nr1 to nr2-richtung step richtung
    seek 1, 4*(i+richtung)+1
    get #1,, temp2
    seek 1, 4*i+1
    put #1,, temp2
  next
  seek 1, 4*nr2+1
  put #1,, temp
  seek 1, 3
  put #1,, levanz
  close #1
end sub

sub warte(byval dauer as double)
  dim as double zeit
  zeit = timer
  do : sleep 1 : loop until timer > zeit + dauer
end sub

sub zeichnefeld(byval reihe as ubyte = 4)
  ' zeichnet das Spielfeld ab Reihe reihe
  for i as ubyte = 1 to 32
    for k as ubyte = reihe to 24
      stein i, k
    next
  next
end sub

sub zeichnemensch
  ' loeschen bzw. zeichnen der Menschen, um Grafikfehler zu vermeiden
  stklein mensch(1).x*20+mensch(1).bewegx*(mensch(1).bewegdauer-1)*2-20, _
          mensch(1).y*20+mensch(1).bewegy*(mensch(1).bewegdauer-1)*2-20, mensch(1).aktuellbild, 2
  'stklein mensch(2).x*20+mensch(2).bewegx*(mensch(2).bewegdauer-1)*2-20, mensch(2).y*20+mensch(2).bewegy*(mensch(2).bewegdauer-1)*2-20, mensch(2).aktuellbild, 2
end sub
